#!/usr/bin/perl
#
#  Blurb-O-Matic.
#
#  Copyright notice must be in a file called `.blurb'; starting with a
#  line that contains a `(c)'.
#

open BLURB, "< .blurb" or die "can't open .blurb";
@blurb = <BLURB>;
close BLURB;

foreach (<*.[ch]>) {
    my $fn = $_;
    open FILE, "< $_" or die "can't open $_: $!";
    open OUT, "> temp" or die "can't create temp file: $!";

    my $printing = 1;
    my $header = 1;
    while(<FILE>) {
	if ($header) {
	    if(m,\*/,) {
		print OUT "  *\n" if $printing;
		$header = 0;
		$printing = 1;
		print OUT @blurb;
		$_ = "  */\n";
	    } 
	    if (m,\(c\),) {
		$printing = 0;
	    }
	}
	print OUT if $printing;
    }
    close FILE;
    close OUT;
    rename "temp", "$fn" or warn "can't rename to $fn: $!";
}
